Index: lemon/bfs.h
===================================================================
--- lemon/bfs.h	(revision 305)
+++ lemon/bfs.h	(revision 220)
@@ -1400,13 +1317,15 @@
 
     /// \brief Destructor.
+    ///
+    /// Destructor.
     ~BfsVisit() {
       if(local_reached) delete _reached;
     }
 
-    /// \brief Sets the map that indicates which nodes are reached.
-    ///
-    /// Sets the map that indicates which nodes are reached.
+    /// \brief Sets the map indicating if a node is reached.
+    ///
+    /// Sets the map indicating if a node is reached.
     /// If you don't use this function before calling \ref run(),
-    /// it will allocate one. The destructor deallocates this
+    /// it will allocate one. The destuctor deallocates this
     /// automatically allocated map, of course.
     /// \return <tt> (*this) </tt>
@@ -1421,21 +1340,19 @@
 
   public:
-
     /// \name Execution control
     /// The simplest way to execute the algorithm is to use
-    /// one of the member functions called \ref lemon::BfsVisit::run()
-    /// "run()".
+    /// one of the member functions called \c run(...).
     /// \n
-    /// If you need more control on the execution, first you must call
-    /// \ref lemon::BfsVisit::init() "init()", then you can add several
-    /// source nodes with \ref lemon::BfsVisit::addSource() "addSource()".
-    /// Finally \ref lemon::BfsVisit::start() "start()" will perform the
-    /// actual path computation.
+    /// If you need more control on the execution,
+    /// first you must call \ref init(), then you can adda source node
+    /// with \ref addSource().
+    /// Finally \ref start() will perform the actual path
+    /// computation.
 
     /// @{
-
     /// \brief Initializes the internal data structures.
     ///
     /// Initializes the internal data structures.
+    ///
     void init() {
       create_maps();
@@ -1465,5 +1382,5 @@
     /// \return The processed node.
     ///
-    /// \pre The queue must not be empty.
+    /// \pre The queue must not be empty!
     Node processNextNode() {
       Node n = _list[++_list_front];
@@ -1486,15 +1403,14 @@
     /// \brief Processes the next node.
     ///
-    /// Processes the next node and checks if the given target node
+    /// Processes the next node. And checks that the given target node
     /// is reached. If the target node is reachable from the processed
-    /// node, then the \c reach parameter will be set to \c true.
+    /// node then the reached parameter will be set true. The reached
+    /// parameter should be initially false.
     ///
     /// \param target The target node.
-    /// \retval reach Indicates if the target node is reached.
-    /// It should be initially \c false.
-    ///
+    /// \retval reach Indicates that the target node is reached.
     /// \return The processed node.
     ///
-    /// \pre The queue must not be empty.
+    /// \warning The queue must not be empty!
     Node processNextNode(Node target, bool& reach) {
       Node n = _list[++_list_front];
@@ -1518,17 +1434,14 @@
     /// \brief Processes the next node.
     ///
-    /// Processes the next node and checks if at least one of reached
-    /// nodes has \c true value in the \c nm node map. If one node
-    /// with \c true value is reachable from the processed node, then the
-    /// \c rnode parameter will be set to the first of such nodes.
-    ///
-    /// \param nm A \c bool (or convertible) node map that indicates the
-    /// possible targets.
+    /// Processes the next node. And checks that at least one of
+    /// reached node has true value in the \c nm node map. If one node
+    /// with true value is reachable from the processed node then the
+    /// rnode parameter will be set to the first of such nodes.
+    ///
+    /// \param nm The node map of possible targets.
     /// \retval rnode The reached target node.
-    /// It should be initially \c INVALID.
-    ///
     /// \return The processed node.
     ///
-    /// \pre The queue must not be empty.
+    /// \warning The queue must not be empty!
     template <typename NM>
     Node processNextNode(const NM& nm, Node& rnode) {
@@ -1551,23 +1464,25 @@
     }
 
-    /// \brief The next node to be processed.
-    ///
-    /// Returns the next node to be processed or \c INVALID if the queue
-    /// is empty.
-    Node nextNode() const {
+    /// \brief Next node to be processed.
+    ///
+    /// Next node to be processed.
+    ///
+    /// \return The next node to be processed or INVALID if the stack is
+    /// empty.
+    Node nextNode() {
       return _list_front != _list_back ? _list[_list_front + 1] : INVALID;
     }
 
     /// \brief Returns \c false if there are nodes
-    /// to be processed.
+    /// to be processed in the queue
     ///
     /// Returns \c false if there are nodes
-    /// to be processed in the queue.
-    bool emptyQueue() const { return _list_front == _list_back; }
+    /// to be processed in the queue
+    bool emptyQueue() { return _list_front == _list_back; }
 
     /// \brief Returns the number of the nodes to be processed.
     ///
     /// Returns the number of the nodes to be processed in the queue.
-    int queueSize() const { return _list_back - _list_front; }
+    int queueSize() { return _list_back - _list_front; }
 
     /// \brief Executes the algorithm.
@@ -1575,48 +1490,19 @@
     /// Executes the algorithm.
     ///
-    /// This method runs the %BFS algorithm from the root node(s)
-    /// in order to compute the shortest path to each node.
-    ///
-    /// The algorithm computes
-    /// - the shortest path tree (forest),
-    /// - the distance of each node from the root(s).
-    ///
-    /// \pre init() must be called and at least one root node should be added
+    /// \pre init() must be called and at least one node should be added
     /// with addSource() before using this function.
-    ///
-    /// \note <tt>b.start()</tt> is just a shortcut of the following code.
-    /// \code
-    ///   while ( !b.emptyQueue() ) {
-    ///     b.processNextNode();
-    ///   }
-    /// \endcode
     void start() {
       while ( !emptyQueue() ) processNextNode();
     }
 
-    /// \brief Executes the algorithm until the given target node is reached.
-    ///
-    /// Executes the algorithm until the given target node is reached.
-    ///
-    /// This method runs the %BFS algorithm from the root node(s)
-    /// in order to compute the shortest path to \c t.
-    ///
-    /// The algorithm computes
-    /// - the shortest path to \c t,
-    /// - the distance of \c t from the root(s).
-    ///
-    /// \pre init() must be called and at least one root node should be
-    /// added with addSource() before using this function.
-    ///
-    /// \note <tt>b.start(t)</tt> is just a shortcut of the following code.
-    /// \code
-    ///   bool reach = false;
-    ///   while ( !b.emptyQueue() && !reach ) {
-    ///     b.processNextNode(t, reach);
-    ///   }
-    /// \endcode
-    void start(Node t) {
+    /// \brief Executes the algorithm until \c dest is reached.
+    ///
+    /// Executes the algorithm until \c dest is reached.
+    ///
+    /// \pre init() must be called and at least one node should be added
+    /// with addSource() before using this function.
+    void start(Node dest) {
       bool reach = false;
-      while ( !emptyQueue() && !reach ) processNextNode(t, reach);
+      while ( !emptyQueue() && !reach ) processNextNode(dest, reach);
     }
 
@@ -1625,26 +1511,13 @@
     /// Executes the algorithm until a condition is met.
     ///
-    /// This method runs the %BFS algorithm from the root node(s) in
-    /// order to compute the shortest path to a node \c v with
-    /// <tt>nm[v]</tt> true, if such a node can be found.
-    ///
-    /// \param nm must be a bool (or convertible) node map. The
-    /// algorithm will stop when it reaches a node \c v with
+    /// \pre init() must be called and at least one node should be added
+    /// with addSource() before using this function.
+    ///
+    ///\param nm must be a bool (or convertible) node map. The
+    ///algorithm will stop when it reaches a node \c v with
     /// <tt>nm[v]</tt> true.
     ///
-    /// \return The reached node \c v with <tt>nm[v]</tt> true or
-    /// \c INVALID if no such node was found.
-    ///
-    /// \pre init() must be called and at least one root node should be
-    /// added with addSource() before using this function.
-    ///
-    /// \note <tt>b.start(nm)</tt> is just a shortcut of the following code.
-    /// \code
-    ///   Node rnode = INVALID;
-    ///   while ( !b.emptyQueue() && rnode == INVALID ) {
-    ///     b.processNextNode(nm, rnode);
-    ///   }
-    ///   return rnode;
-    /// \endcode
+    ///\return The reached node \c v with <tt>nm[v]</tt> true or
+    ///\c INVALID if no such node was found.
     template <typename NM>
     Node start(const NM &nm) {
@@ -1656,14 +1529,8 @@
     }
 
-    /// \brief Runs the algorithm from the given source node.
-    ///
-    /// This method runs the %BFS algorithm from node \c s
-    /// in order to compute the shortest path to each node.
-    ///
-    /// The algorithm computes
-    /// - the shortest path tree,
-    /// - the distance of each node from the root.
-    ///
-    /// \note <tt>b.run(s)</tt> is just a shortcut of the following code.
+    /// \brief Runs %BFSVisit algorithm from node \c s.
+    ///
+    /// This method runs the %BFS algorithm from a root node \c s.
+    /// \note b.run(s) is just a shortcut of the following code.
     ///\code
     ///   b.init();
@@ -1677,41 +1544,17 @@
     }
 
-    /// \brief Finds the shortest path between \c s and \c t.
-    ///
-    /// This method runs the %BFS algorithm from node \c s
-    /// in order to compute the shortest path to node \c t
-    /// (it stops searching when \c t is processed).
-    ///
-    /// \return \c true if \c t is reachable form \c s.
-    ///
-    /// \note Apart from the return value, <tt>b.run(s,t)</tt> is just a
-    /// shortcut of the following code.
-    ///\code
-    ///   b.init();
-    ///   b.addSource(s);
-    ///   b.start(t);
-    ///\endcode
-    bool run(Node s,Node t) {
-      init();
-      addSource(s);
-      start(t);
-      return reached(t);
-    }
-
-    /// \brief Runs the algorithm to visit all nodes in the digraph.
+    /// \brief Runs %BFSVisit algorithm to visit all nodes in the digraph.
     ///
     /// This method runs the %BFS algorithm in order to
-    /// compute the shortest path to each node.
-    ///
-    /// The algorithm computes
-    /// - the shortest path tree (forest),
-    /// - the distance of each node from the root(s).
-    ///
-    /// \note <tt>b.run(s)</tt> is just a shortcut of the following code.
+    /// compute the %BFS path to each node. The algorithm computes
+    /// - The %BFS tree.
+    /// - The distance of each node from the root in the %BFS tree.
+    ///
+    ///\note b.run() is just a shortcut of the following code.
     ///\code
     ///  b.init();
-    ///  for (NodeIt n(gr); n != INVALID; ++n) {
-    ///    if (!b.reached(n)) {
-    ///      b.addSource(n);
+    ///  for (NodeIt it(digraph); it != INVALID; ++it) {
+    ///    if (!b.reached(it)) {
+    ///      b.addSource(it);
     ///      b.start();
     ///    }
@@ -1727,5 +1570,4 @@
       }
     }
-
     ///@}
 
@@ -1733,18 +1575,17 @@
     /// The result of the %BFS algorithm can be obtained using these
     /// functions.\n
-    /// Either \ref lemon::BfsVisit::run() "run()" or
-    /// \ref lemon::BfsVisit::start() "start()" must be called before
-    /// using them.
+    /// Before the use of these functions,
+    /// either run() or start() must be called.
     ///@{
 
-    /// \brief Checks if a node is reachable from the root(s).
+    /// \brief Checks if a node is reachable from the root.
     ///
     /// Returns \c true if \c v is reachable from the root(s).
+    /// \warning The source nodes are inditated as unreachable.
     /// \pre Either \ref run() or \ref start()
     /// must be called before using this function.
+    ///
     bool reached(Node v) { return (*_reached)[v]; }
-
     ///@}
-
   };
 
@@ -1752,2 +1593,3 @@
 
 #endif
+
